use rand::{thread_rng, Rng};

fn exponential_distribution(random_number: f64, lambda: f64) -> f64 {
    -(1f64 / lambda) * random_number.ln()
}

fn average(distribution: &[f64]) -> f64 {
    distribution.iter().sum::<f64>() / SAMPLE_SIZE as f64
}

const SAMPLE_SIZE: usize = 100;
const CHUNK_SIZE: usize = SAMPLE_SIZE / 4;

fn main() {
    let mut rng = thread_rng();

    let lambda: f64 = 0.2;
    let mut x: Vec<f64> = (0..SAMPLE_SIZE)
        .map(|_| exponential_distribution(rng.gen(), lambda))
        .collect();
    x.sort_by(|a, b| a.partial_cmp(b).unwrap());

    // let lambda_experimental: f64 = 1f64 / average(&x);
    dbg!(average(&x));
    dbg!(1f64 / lambda);

    // dbg!(lambda_experimental);

    let mut probabilities: Vec<f64> = x
        .chunks(CHUNK_SIZE)
        .map(|i| 1f64 - (-lambda * i.last().unwrap_or(&0f64)).exp())
        .collect(); // Os' jak ja šukaju jmovirnosti [P1, P', ...].

    (1..probabilities.len())
        .rev()
        .for_each(|i| probabilities[i] -= probabilities[i - 1]); // I os' tut ja jih peretvorjuju na [P1, P2, ...]

    /*let mut hi2_1: f64 = 0f64;

    (0..probabilities.len())
        .for_each(|i| hi2_1 += CHUNK_SIZE.pow(2) as f64 / (SAMPLE_SIZE as f64 * probabilities[i]));

    hi2_1 -= SAMPLE_SIZE as f64;

    dbg!(hi2_1);*/

    let mut hi2_2: f64 = 0f64;

    (0..probabilities.len()).for_each(|i| {
        hi2_2 += (SAMPLE_SIZE as f64)
            .mul_add(-probabilities[i], CHUNK_SIZE as f64)
            .powi(2)
            / (SAMPLE_SIZE as f64 * probabilities[i]);
    });

    dbg!(hi2_2);

    let something = "Žaba!";

    println!("Hello {something}!")
}
